# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# From SI-score repo

"""Dictionary mapping labels (strings) to imagenet classes (ints).

Generated manually.
"""

label_str_to_imagenet_classes = {
    'ambulance': 407,
    'armadillo': 363,
    'artichoke': 944,
    'backpack': 414,
    'bagel': 931,
    'balance beam': 416,
    'banana': 954,
    'band-aid': 419,
    'beaker': 438,
    'bell pepper': 945,
    'billiard table': 736,
    'binoculars': 447,
    'broccoli': 937,
    'brown bear': 294,
    'burrito': 965,
    'candle': 470,
    'canoe': 472,
    'cello': 486,
    'cheetah': 293,
    'cocktail shaker': 503,
    'common fig': 952,
    'computer mouse': 673,
    'cowboy hat': 515,
    'cucumber': 943,
    'diaper': 529,
    'digital clock': 530,
    'dumbbell': 543,
    'envelope': 549,
    'eraser': 767,
    'filing cabinet': 553,
    'flowerpot': 738,
    'flute': 558,
    'frying pan': 567,
    'golf ball': 574,
    'goose': 99,
    'guacamole': 924,
    'hair dryer': 589,
    'hair spray': 585,
    'hammer': 587,
    'hamster': 333,
    'harmonica': 593,
    'hedgehog': 334,
    'hippopotamus': 344,
    'hot dog': 934,
    'ipod': 605,
    'jeans': 608,
    'kite': 21,
    'koala': 105,
    'ladle': 618,
    'laptop': 620,
    'lemon': 951,
    'light switch': 844,
    'lighthouse': 437,
    'limousine': 627,
    'lipstick': 629,
    'lynx': 287,
    'magpie': 18,
    'maracas': 641,
    'measuring cup': 647,
    'microwave oven': 651,
    'miniskirt': 655,
    'missile': 657,
    'mixing bowl': 659,
    'mobile phone': 487,
    'mushroom': 947,
    'orange': 950,
    'ostrich': 9,
    'otter': 360,
    'paper towel': 700,
    'pencil case': 709,
    'pig': 341,
    'pillow': 721,
    'pitcher (container)': 725,
    'pizza': 963,
    'plastic bag': 728,
    'polar bear': 296,
    'pomegranate': 957,
    'pretzel': 932,
    'printer': 742,
    'punching bag': 747,
    'racket': 752,
    'red panda': 387,
    'remote control': 761,
    'rugby ball': 768,
    'ruler': 769,
    'saxophone': 776,
    'screwdriver': 784,
    'sea lion': 150,
    'seat belt': 785,
    'skunk': 361,
    'snowmobile': 802,
    'soap dispenser': 804,
    'sock': 806,
    'sombrero': 808,
    'spatula': 813,
    'starfish': 327,
    'strawberry': 949,
    'studio couch': 831,
    'taxi': 468,
    'teapot': 849,
    'teddy bear': 850,
    'tennis ball': 852,
    'toaster': 859,
    'toilet paper': 999,
    'torch': 862,
    'traffic light': 920,
    'vase': 883,
    'volleyball (ball)': 890,
    'washing machine': 897,
    'wok': 909,
    'zebra': 340,
    'zucchini': 939
}
